//Copyright (c) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;

namespace Eas.WebCrawler.Common {
    /// <summary>An <see cref="System.EventArgs"/> implementation which wraps a provided generic type.</summary>
    public class EventArgs<_ArgType> : System.EventArgs {
        private _ArgType _Argument;
        private EventArgs() { }

        /// <summary>Constructs an <see cref="EventArgs"/> from a given argument.</summary>
        /// <param name="argument">The value which this <see cref="EventArgs"/> wraps</param>
        public EventArgs(_ArgType argument) {
            _Argument = argument;
        }

        /// <summary>The contained argument.</summary>
        public _ArgType Argument {
            get {
                return _Argument;
            }
        }
    }
}
