//Copyright (c) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;

namespace Eas.WebCrawler.Interfaces {
    /// <summary>The level of tracing to use while processing.</summary>
    public enum TraceLevel {
        /// <summary>No Tracing should be performed.</summary>
        None = 0,
        /// <summary>Only critical traces should be issued.</summary>
        Critical = 1,
        /// <summary>Only high inpact or critical traces should be issued.</summary>
        HighImpact = 2,
        /// <summary>Only detailed, high impact, and critical traces should be issued.</summary>
        Detailed = 3,
        /// <summary>Only annoyingly detailed, detailed, high impact and critical traces should be issued.</summary>
        Annoying = 4,
        /// <summary>Issue all traces.</summary>
        All = int.MaxValue
    }
}
