//Copyright (c) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;

namespace Eas.WebCrawler.Interfaces {
    /// <summary>Classes which implement this interface will be initialized by the <see cref="WebCrawlerContext"/> into which they are passed.</summary>
    public interface WebCrawlerComponent {
        /// <summary>Initializes the component.</summary>
        /// <param name="context">The <see cref="WebCrawlerContext"/> to which this component belongs.</param>
        void Initialize(WebCrawlerContext context);
        
    }
}
