//Copyright (c) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;

namespace Eas.WebCrawler.Model.Core {

    internal class WebFailureException : Exception {
        /// <summary>The http response code of the failure, if available, otherwise <code>-1</code>.</summary>
        /// <remarks>Backing field for the ResponseCode property.</remarks>
        /// <seealso cref="ResponseCode"/>
        private int _ResponseCode=-1;

        public WebFailureException(string message, int responseCode, Exception inner) : base(message, inner) {
            _ResponseCode = responseCode;
        }

        /// <summary>The http response code of the failure, if available, otherwise <code>-1</code>.</summary>
        public int ResponseCode {
            get { return _ResponseCode; }
            set { _ResponseCode = value; }
        }
                
    }
}
