//Copyright (c) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;

namespace Eas.WebCrawler.Model.StorageWriters {
    internal class BinaryStorageWriter : Eas.WebCrawler.Common.BaseDisposable, StorageWriter {
        System.IO.BinaryWriter _Writer;
        
        public BinaryStorageWriter() { }

        protected override void Dispose(bool isDisposing) {
            try {
                if (isDisposing) {
                    if (_Writer != null) {
                        ((IDisposable)_Writer).Dispose();
                        _Writer = null;
                    }
                }
            }
            finally {
                base.Dispose(isDisposing);
            }
        }

        #region StorageWriter Members

        public void Initialize(Eas.WebCrawler.Interfaces.TemporaryStorage storage) {
            _Writer = storage.GetBinaryWriter();
        }

        public void Add(byte[] buffer, int count) {
            _Writer.Write(buffer, 0, count);
        }

        #endregion

    }
}
