//Copyright (c) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;

namespace Eas.WebCrawler.PlugIns.RequestComparers
{
    /// <summary>A comparer that considers all requests to be equal.</summary>
    public class AlwaysEqualComparer : BaseComparer
    {
        /// <summary>Compares two <see cref="Uri"/>s to see which is higher priority.  This implementation will always evaluate requests as being equal.</summary>
        /// <param name="leftRequest">The left <see cref="Eas.WebCrawler.Interfaces.Request"/> to compare.</param>
        /// <param name="rightRequest">The right <see cref="Eas.WebCrawler.Interfaces.Request"/> to compare.</param>
        /// <returns>This implementation always returns <see cref="CompareResult.PrioritiesAreEqual"/>.</returns>
        public override CompareResult CompareUris(Eas.WebCrawler.Interfaces.Request leftRequest, Eas.WebCrawler.Interfaces.Request rightRequest)
        {
            return CompareResult.PrioritiesAreEqual;
        }
    }
}
