//Copyright (c) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;

namespace Eas.WebCrawler.PlugIns.UrlProcessedHandlers {
    /// <summary>A base helper class that can (but need not be) used when handling <see cref="Eas.WebCrawler.Interfaces.WebCrawlerEvents.UrlProcessed"/> events fired by the web crawler.</summary>
    public interface UrlProcessedHandler {
        /// <summary>Handles the <see cref="Eas.WebCrawler.Interfaces.WebCrawlerEvents.UrlProcessed"/> event fired by the web crawler when registered to do so.</summary>
        /// <param name="sender">The sender of the event.</param>
        /// <param name="argument">Details of the processed url.</param>
        void UrlProcessed(object sender, Eas.WebCrawler.Interfaces.UrlCompletedEventArgs argument);
    }
}
