//Copyright (c) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;
using Eas.WebCrawler.Interfaces;

namespace Eas.WebCrawler.Test.PlugIns {
    public class TestProcessingState : Eas.WebCrawler.Interfaces.ProcessingState {
        internal int _Id;
        internal Request _Request;
//        internal WebRequestInterface _WebRequest;
//        internal WebResponseInterface _WebResponse;
        internal System.IO.Stream _ResponseStream;
        internal bool _IsTextResponse;
        internal bool _WasPaused;
        internal WorkerState _WorkerState;
//        internal TemporaryStorage _Storage;

        public TestProcessingState(int id) : this(id, true, false, WorkerState.Unstarted) { }



        public TestProcessingState(int id, bool isTextResponse, bool wasPaused, WorkerState workerSate) {
            _Id = id;
            _IsTextResponse = isTextResponse;
            _WasPaused = false;
            _WorkerState = workerSate;
        }

        public TestProcessingState(int id, Request request, bool isTextResponse, System.IO.Stream stream)
            : this(id, isTextResponse, false, WorkerState.Working) {
            this._Request = request;
            this._ResponseStream = stream;
        }

        #region ProcessingState Members

        public TemporaryStorage ResponseStore {
            get { return null;}// _Storage; }
        }

        public Request Request {
            get { return _Request; }
        }

        public Eas.WebCrawler.Interfaces.WebRequestInterface WebRequest {
            get { return null;}// ; }
        }

        public Eas.WebCrawler.Interfaces.WebResponseInterface WebResponse {
            get { return null;}// _WebResponse; }
        }

        public System.IO.Stream ResponseStream {
            get { return _ResponseStream; }
        }

        public bool IsTextResponse {
            get { return _IsTextResponse; }
        }

        public int Id {
            get { return _Id; }
        }

        public bool WasPaused {
            get { return _WasPaused; }
        }

        public Eas.WebCrawler.Interfaces.WorkerState WorkerState {
            get { return _WorkerState; }
        }

        public void RequestChange(WorkerState workerState) { }
        public void CopyChangeRequests(ProcessingState state) { }

        #endregion

        #region IDisposable Members

        public void Dispose() { }

        #endregion
    }
}
